#!/usr/bin/env python

import notifier
import mbus
notifier.init(notifier.GENERIC)

class DefaultSignals:
	def new(self, maddr ):
	    print "New Entity:", str( maddr )

	def lost(self, maddr ):
	    print "Lost Entity:", str( maddr )

	def unknown(self, mmessage ):
	    print "received unknown message:"
	    print str(mmessage)

	def transporterror(self, e ):
	    print "Mbus transport error occured:", e.descr
	    print "MMessage content:"
	    if e.mmsg:
		print e.mmsg.header.srcAdr, e.mmsg.header.destAdr

	def __init__(self, entity):
		if entity: self.connect(entity)

	def connect(self, entity):
		entity.signal_connect( 'new-entity', self.new )
		entity.signal_connect( 'lost-entity', self.new )
		entity.signal_connect( 'unknown-message', self.unknown )
		entity.signal_connect( 'error', self.transporterror )

class MNetBus:
	entity = None
	def __init__(self, app = "mnet-flow-source"):
		self.addr = "lang:python app:%s" % app
		self.entity = mbus.Entity(self.addr)
	def send(self, flow = None, addr = "app:mnet-flow-sink", func = "flow-sink"):
		return self.entity.send(addr, func, [flow])
	def sink(self):
		DefaultSignals(self.entity)
		self.entity.addCallback("flow-sink", self.flow_sink)
	def flow_sink(self, mmsg, data = None):
		print "Flow sink is not implemented..."
		return True
	
	def loop(self):
		try:
			notifier.loop()
		except mbus.types.MError, e:
			print e.descr
			print e.mmsg
		except KeyboardInterrupt:
			pass
